unit Tstftfrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Filt_tbl, Grids, DBGrids, StdCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    FilterTable1: TFilterTable;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FilterTable1FilterRecord(DataSet: TDataset;
      var Accept: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FilterTable1.Filter := Edit1.Text;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if (FilterTable1.DatabaseName = '') then
  begin
{   if FileExists(ExtractFilePath(Application.ExeName) +
                  FilterTable1.TableName + '.DB') then }
      FilterTable1.DatabaseName := ExtractFilePath(Application.ExeName);

{
    else
    begin
      ShowMessage('Please set FilterTable1.DatabaseName to the location of ' +
                  FilterTable1.TableName + '.DB or copy ' +
                  FilterTable1.TableName +
                  '.* to the location of ' + Application.ExeName);
      halt;
    end;
}
  end;
  FilterTable1.Active := true;
end;

procedure TForm1.FilterTable1FilterRecord(DataSet: TDataset;
  var Accept: Boolean);
const
  fldBool: Integer = -1;
begin
{ DataSet is not TFilterTable1 but it is a copy! (Delphi 1 only)
  For this, you can not work with fields like 'FilterTable1Bool' here but
  you have to use DataSet.Fields[...].Value. But be careful:
  DataSet is not TFilterTable1 but it is a copy! The fieldnumbers can differ
  e.g. if you insert calculated fields. This is a save method to access a field:
  DataSet.FieldByName('...').Value.
  This is the optimized version: }

  if (fldBool = -1) then { first call: }
    fldBool := DataSet.FieldByName('Bool').Index; { called once }
  Accept := DataSet.Fields[fldBool].AsBoolean;

{ Delete next line if you want to test this procedure: }
  Accept := true; { I want to show all records until you find this }
end;

end.
